﻿'Prologue


Public Class frmSortZipCodes
    'Create arrays for each field from data file
    Dim mstrZip() As String
    Dim mstrState() As String
    Dim mstrCity() As String
    Dim msngLong() As Single
    Dim msngLat() As Single
    Dim mintPop() As Integer

    Private Sub btnLoad_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLoad.Click
        'Declarations
        Dim srdFile As System.IO.StreamReader
        Dim strFields() As String
        Dim strLine As String
        Dim strDetail As String
        Dim i As Integer

        'Input
        srdFile = New System.IO.StreamReader("ZipCodes.dat")

        Do While srdFile.Peek <> -1
            ReDim Preserve mstrZip(i)
            ReDim Preserve mstrState(i)
            ReDim Preserve mstrCity(i)
            ReDim Preserve msngLong(i)
            ReDim Preserve msngLat(i)
            ReDim Preserve mintPop(i)

            'Read
            strLine = srdFile.ReadLine()
            'Parse
            strFields = strLine.Split(",")

            mstrZip(i) = strFields(0)
            mstrState(i) = strFields(1)
            mstrCity(i) = strFields(2)
            msngLong(i) = Convert.ToSingle(strFields(3))
            msngLat(i) = Convert.ToSingle(strFields(4))
            mintPop(i) = Convert.ToInt32(strFields(5))

            'Display record
            strDetail = mstrZip(i).PadRight(7) & _
            mstrState(i).PadRight(5) & _
            mstrCity(i).PadRight(35) & _
            msngLong(i).ToString("n3").PadLeft(7) & _
            msngLat(i).ToString("n3").PadLeft(7) & _
            mintPop(i).ToString("n0").PadLeft(12) & vbNewLine
            rtbOut.AppendText(strDetail)

            'Increment counter
            i = i + 1

            'Display number of records read
            'Refresh forces update of lblRecords
            lblRecords.Text = i.ToString("N0")
            lblRecords.Refresh()

        Loop

        'Close
        srdFile.Close()

        'Reset buttons
        btnSortZipAlpha.Enabled = True
        btnSortZipReverse.Enabled = True
        btnSortCityAlpha.Enabled = True
        btnSortCityReverse.Enabled = True
        btnLoad.Enabled = False

    End Sub

    Private Sub btnExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExit.Click
        End

    End Sub

    Private Sub btnSortZipAlpha_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSortZipAlpha.Click
        Dim i As Integer
        Dim j As Integer
        Dim intNext As Integer
        Dim intPasses As Integer
        Dim strDetail As String
        Dim strTemp As String
        Dim intTemp As Integer
        Dim sngTemp As Single

        rtbOut.Clear()
        rtbOut.AppendText("Sorting")
        rtbOut.Refresh()

        'Sort in ascending order by zip code
        For i = 0 To mstrZip.GetUpperBound(0) - 1
            For j = 0 To mstrZip.GetUpperBound(0) - 1 - i
                intNext = j + 1
                If mstrZip(j) > mstrZip(intNext) Then
                    strTemp = mstrZip(j)
                    mstrZip(j) = mstrZip(intNext)
                    mstrZip(intNext) = strTemp
                    strTemp = mstrState(j)
                    mstrState(j) = mstrState(intNext)
                    mstrState(intNext) = strTemp
                    strTemp = mstrCity(j)
                    mstrCity(j) = mstrCity(intNext)
                    mstrCity(intNext) = strTemp
                    sngTemp = msngLong(j)
                    msngLong(j) = msngLong(intNext)
                    msngLong(intNext) = sngTemp
                    sngTemp = msngLat(j)
                    msngLat(j) = msngLat(intNext)
                    msngLat(intNext) = sngTemp
                    intTemp = mintPop(j)
                    mintPop(j) = mintPop(intNext)
                    mintPop(intNext) = intTemp

                End If
                intPasses += 1

            Next j

            'Displays number of records sorted
            lblRecords.Text = i.ToString("N0")
            lblRecords.Refresh()
            'Displays number of passes
            lblPasses.Text = intPasses.ToString("n0")
            lblPasses.Refresh()

        Next i

        lblRecords.Text = i.ToString("N0")

        rtbOut.Clear()

        'Display sorted records
        For i = 0 To mstrZip.GetUpperBound(0)
            strDetail = mstrZip(i).PadRight(7) & _
            mstrState(i).PadRight(5) & _
            mstrCity(i).PadRight(35) & _
            msngLong(i).ToString("n3").PadLeft(7) & _
            msngLat(i).ToString("n3").PadLeft(7) & _
            mintPop(i).ToString("n0").PadLeft(12) & _
            vbNewLine
            rtbOut.AppendText(strDetail)

            'Display number of records and force update of label
            lblRecords.Text = i.ToString("N0")
            lblRecords.Refresh()
        Next i

        lblRecords.Text = i.ToString("N0")

    End Sub

    Private Sub btnSortZipReverse_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSortZipReverse.Click
        Dim i As Integer
        Dim j As Integer
        Dim intNext As Integer
        Dim intPasses As Integer
        Dim strDetail As String
        Dim strTemp As String
        Dim intTemp As Integer
        Dim sngTemp As Single

        rtbOut.Clear()
        rtbOut.AppendText("Sorting")
        rtbOut.Refresh()

        'Sort in descending order by zip code
        For i = 0 To mstrZip.GetUpperBound(0) - 1
            For j = 0 To mstrZip.GetUpperBound(0) - 1 - i
                intNext = j + 1
                If mstrZip(j) < mstrZip(intNext) Then
                    strTemp = mstrZip(j)
                    mstrZip(j) = mstrZip(intNext)
                    mstrZip(intNext) = strTemp
                    strTemp = mstrState(j)
                    mstrState(j) = mstrState(intNext)
                    mstrState(intNext) = strTemp
                    strTemp = mstrCity(j)
                    mstrCity(j) = mstrCity(intNext)
                    mstrCity(intNext) = strTemp
                    sngTemp = msngLong(j)
                    msngLong(j) = msngLong(intNext)
                    msngLong(intNext) = sngTemp
                    sngTemp = msngLat(j)
                    msngLat(j) = msngLat(intNext)
                    msngLat(intNext) = sngTemp
                    intTemp = mintPop(j)
                    mintPop(j) = mintPop(intNext)
                    mintPop(intNext) = intTemp

                End If
                intPasses += 1

            Next j

            'Displays number of records sorted
            lblRecords.Text = i.ToString("N0")
            lblRecords.Refresh()
            'Displays number of passes
            lblPasses.Text = intPasses.ToString("n0")
            lblPasses.Refresh()

        Next i

        lblRecords.Text = i.ToString("N0")

        rtbOut.Clear()

        'Display sorted records
        For i = 0 To mstrZip.GetUpperBound(0)
            strDetail = mstrZip(i).PadRight(7) & _
            mstrState(i).PadRight(5) & _
            mstrCity(i).PadRight(35) & _
            msngLong(i).ToString("n3").PadLeft(7) & _
            msngLat(i).ToString("n3").PadLeft(7) & _
            mintPop(i).ToString("n0").PadLeft(12) & _
            vbNewLine
            rtbOut.AppendText(strDetail)

            'Display number of records and force update of label
            lblRecords.Text = i.ToString("N0")
            lblRecords.Refresh()
        Next i

        lblRecords.Text = i.ToString("N0")
        lblRecords.Refresh()

    End Sub

    Private Sub btnCity_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSortCityAlpha.Click
        Dim i As Integer
        Dim j As Integer
        Dim intNext As Integer
        Dim intPasses As Integer
        Dim strDetail As String
        Dim strTemp As String
        Dim intTemp As Integer
        Dim sngTemp As Single

        rtbOut.Clear()
        rtbOut.AppendText("Sorting")
        rtbOut.Refresh()

        'Sort in ascending order by city
        For i = 0 To mstrZip.GetUpperBound(0) - 1
            For j = 0 To mstrZip.GetUpperBound(0) - 1 - i
                intNext = j + 1
                If mstrCity(j) > mstrCity(intNext) Then
                    strTemp = mstrZip(j)
                    mstrZip(j) = mstrZip(intNext)
                    mstrZip(intNext) = strTemp
                    strTemp = mstrState(j)
                    mstrState(j) = mstrState(intNext)
                    mstrState(intNext) = strTemp
                    strTemp = mstrCity(j)
                    mstrCity(j) = mstrCity(intNext)
                    mstrCity(intNext) = strTemp
                    sngTemp = msngLong(j)
                    msngLong(j) = msngLong(intNext)
                    msngLong(intNext) = sngTemp
                    sngTemp = msngLat(j)
                    msngLat(j) = msngLat(intNext)
                    msngLat(intNext) = sngTemp
                    intTemp = mintPop(j)
                    mintPop(j) = mintPop(intNext)
                    mintPop(intNext) = intTemp

                End If
                intPasses += 1

            Next j

            'Displays number of records sorted
            lblRecords.Text = i.ToString("N0")
            lblRecords.Refresh()
            'Displays number of passes
            lblPasses.Text = intPasses.ToString("n0")
            lblPasses.Refresh()

        Next i

        lblRecords.Text = i.ToString("N0")
        lblRecords.Refresh()

        rtbOut.Clear()

        'Display sorted records
        For i = 0 To mstrZip.GetUpperBound(0)
            strDetail = mstrZip(i).PadRight(7) & _
            mstrState(i).PadRight(5) & _
            mstrCity(i).PadRight(35) & _
            msngLong(i).ToString("n3").PadLeft(7) & _
            msngLat(i).ToString("n3").PadLeft(7) & _
            mintPop(i).ToString("n0").PadLeft(12) & _
            vbNewLine
            rtbOut.AppendText(strDetail)

            'Display number of records and force update of label
            lblRecords.Text = i.ToString("N0")
            lblRecords.Refresh()
        Next i

        lblRecords.Text = i.ToString("N0")
        lblRecords.Refresh()

    End Sub

    Private Sub btnSortCityReverse_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSortCityReverse.Click
        Dim i As Integer
        Dim j As Integer
        Dim intNext As Integer
        Dim intPasses As Integer
        Dim strDetail As String
        Dim strTemp As String
        Dim intTemp As Integer
        Dim sngTemp As Single

        rtbOut.Clear()
        rtbOut.AppendText("Sorting")
        rtbOut.Refresh()

        'Sort in descending order by city
        For i = 0 To mstrZip.GetUpperBound(0) - 1
            For j = 0 To mstrZip.GetUpperBound(0) - 1 - i
                intNext = j + 1
                If mstrCity(j) < mstrCity(intNext) Then
                    strTemp = mstrZip(j)
                    mstrZip(j) = mstrZip(intNext)
                    mstrZip(intNext) = strTemp
                    strTemp = mstrState(j)
                    mstrState(j) = mstrState(intNext)
                    mstrState(intNext) = strTemp
                    strTemp = mstrCity(j)
                    mstrCity(j) = mstrCity(intNext)
                    mstrCity(intNext) = strTemp
                    sngTemp = msngLong(j)
                    msngLong(j) = msngLong(intNext)
                    msngLong(intNext) = sngTemp
                    sngTemp = msngLat(j)
                    msngLat(j) = msngLat(intNext)
                    msngLat(intNext) = sngTemp
                    intTemp = mintPop(j)
                    mintPop(j) = mintPop(intNext)
                    mintPop(intNext) = intTemp

                End If
                intPasses += 1

            Next j

            'Displays number of records sorted
            lblRecords.Text = i.ToString("N0")
            lblRecords.Refresh()
            'Displays number of passes
            lblPasses.Text = intPasses.ToString("n0")
            lblPasses.Refresh()

        Next i

        lblRecords.Text = i.ToString("N0")
        lblRecords.Refresh()

        rtbOut.Clear()

        'Display sorted records
        For i = 0 To mstrZip.GetUpperBound(0)
            strDetail = mstrZip(i).PadRight(7) & _
            mstrState(i).PadRight(5) & _
            mstrCity(i).PadRight(35) & _
            msngLong(i).ToString("n3").PadLeft(7) & _
            msngLat(i).ToString("n3").PadLeft(7) & _
            mintPop(i).ToString("n0").PadLeft(12) & _
            vbNewLine
            rtbOut.AppendText(strDetail)

            'Display number of records and force update of label
            lblRecords.Text = i.ToString("N0")
            lblRecords.Refresh()
        Next i

        lblRecords.Text = i.ToString("N0")
        lblRecords.Refresh()

    End Sub
End Class
