Public Class frmStudTestScores
    'Declarations
    Dim mstrID() As String
    Dim mbytScores1() As Byte
    Dim mbytScores2() As Byte
    Dim mbytScores3() As Byte
    Dim mbytScores4() As Byte
    Dim mintCount As Integer

    Private Sub mnuFileLoadScores_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileLoadScores.Click
        Dim strField() As String
        Dim srdFile As System.IO.StreamReader
        Dim strLine As String
        Const chrDelimiter As Char = ","

        'Open File
        ofdScores.ShowDialog()
        srdFile = New System.IO.StreamReader(ofdScores.FileName)

        'Read
        strLine = srdFile.ReadLine()

        Do While (strLine <> Nothing)
            ReDim Preserve mstrID(mintCount)
            ReDim Preserve mbytScores1(mintCount)
            ReDim Preserve mbytScores2(mintCount)
            ReDim Preserve mbytScores3(mintCount)
            ReDim Preserve mbytScores4(mintCount)

            'Parse
            strField = strLine.Split(chrDelimiter)

            mstrID(mintCount) = strField(0)
            mbytScores1(mintCount) = System.Convert.ToInt16(strField(1))
            mbytScores2(mintCount) = System.Convert.ToInt16(strField(2))
            mbytScores3(mintCount) = System.Convert.ToInt16(strField(3))
            mbytScores4(mintCount) = System.Convert.ToInt16(strField(4))
            strLine = srdFile.ReadLine()
            mintCount = mintCount + 1

        Loop

        'Close
        srdFile.Close()

        mnuFileLoadScores.Enabled = False
        mnuFileSaveGrades.Enabled = True

    End Sub

    Private Sub TestScores(ByVal bytTest As Byte, ByVal TestScores As Array)
        'Report for Test 1 Scores
        Dim i As Integer
        Dim sngMean As Single
        Dim intMedian As Integer
        Dim bytMode As Byte
        Dim sngStDev As Single
        Dim bytTemp(mintCount - 1) As Byte
        Dim strHighID(0) As String
        Dim bytHighScore As Byte
        Dim bytHighScoresCount As Byte

        'Processing

        'Find High Scores(s)
        For i = 0 To TestScores.GetUpperBound(0)
            If TestScores(i) > bytHighScore Then
                ReDim strHighID(0)
                bytHighScoresCount = 0
                bytHighScore = TestScores(i)
            End If
            If TestScores(i) = bytHighScore Then
                ReDim Preserve strHighID(bytHighScoresCount)
                strHighID(bytHighScoresCount) = mstrID(i)
                bytHighScoresCount = bytHighScoresCount + 1
            End If
        Next i

        'Find Mean
        sngMean = FindMean(TestScores)

        'Find Median
        intMedian = mintCount \ 2

        'Sort Scores
        Array.Copy(TestScores, bytTemp, TestScores.Length)

        bytTemp = SortScores(bytTemp)

        'Find Mode
        bytMode = FindMode(bytTemp)

        'Find Standard Deviation
        sngStDev = FindStDev(bytTemp)

        'Output
        rtbOut.AppendText("             Test " & bytTest.ToString & " Results" & ControlChars.NewLine & ControlChars.NewLine)
        rtbOut.AppendText("Total Students: " & mintCount.ToString & ControlChars.NewLine)
        rtbOut.AppendText("Mean Score: " & sngMean.ToString("N2") & ControlChars.NewLine)
        rtbOut.AppendText("Median Score: " & bytTemp(intMedian).ToString("N0") & ControlChars.NewLine)
        rtbOut.AppendText("Mode Score: " & bytMode.ToString("N0") & ControlChars.NewLine)
        rtbOut.AppendText("Standard Deviation: " & sngStDev.ToString("N2") & ControlChars.NewLine)
        rtbOut.AppendText("High Score: " & bytHighScore.ToString & ControlChars.NewLine)
        rtbOut.AppendText("High Scorers:" & ControlChars.NewLine)
        For i = 0 To bytHighScoresCount - 1
            rtbOut.AppendText(strHighID(i) & ControlChars.NewLine)
        Next i
        rtbOut.AppendText(ControlChars.NewLine)
    End Sub

    Private Function SortScores(ByVal bytScores As Array) As System.Array

        Dim i, j As Integer
        Dim intMin As Integer
        Dim bytTemp As Byte

        For i = 0 To bytScores.GetUpperBound(0) - 1
            intMin = i
            For j = i + 1 To bytScores.GetUpperBound(0)
                If bytScores(intMin) > bytScores(j) Then
                    intMin = j
                End If
            Next j
            bytTemp = bytScores(i)
            bytScores(i) = bytScores(intMin)
            bytScores(intMin) = bytTemp

        Next i

        SortScores = bytScores

    End Function
  
    Private Function FindMean(ByVal bytScores As Array) As Single
        Dim i As Integer
        Dim lngTotal As Long

        For i = 0 To bytScores.GetUpperBound(0)
            lngTotal = lngTotal + bytScores(i)
        Next i
        FindMean = lngTotal / bytScores.GetLength(0)

    End Function

     Private Function FindMode(ByVal bytScores As Array) As Byte
        Dim intMode As Integer
        Dim i As Integer
        Dim intCount As Integer
        Dim intCountTemp As Integer

        For i = 0 To bytScores.GetUpperBound(0) - 1
            If bytScores(i) = bytScores(i + 1) Then
                intCountTemp = intCountTemp + 1
                If intCountTemp > intCount Then
                    intMode = bytScores(i)
                    intCount = intCountTemp
                End If
            Else
                intCountTemp = 0
            End If
        Next i

        FindMode = intMode
    End Function

    Private Function FindStDev(ByVal bytScores As Array) As Single
        Dim dblStDev As Double
        Dim intSum As Integer
        Dim intSumSquare As Integer
        Dim i As Long

        ' evaluate sum of values
        For i = 0 To bytScores.GetUpperBound(0)
            ' add to the running total
            intSum = intSum + bytScores(i)
            intSumSquare = intSumSquare + (bytScores(i) * bytScores(i))
        Next i
        ' evaluate the result
        dblStDev = System.Math.Sqrt((intSumSquare - (intSum * intSum / bytScores.Length)) / bytScores.Length)

        FindStDev = dblStDev
    End Function
    
    Private Sub mnuFileSaveGrades_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileSaveGrades.Click
        Dim swrFile As System.IO.StreamWriter
        Dim strLine As String
        Dim strGrade As String
        Dim intTotal As Integer
        Dim i As Integer
        Dim sngAverage(mintCount) As Single
        Dim j As Integer
        Dim intMin As Integer
        Dim strTemp As String
        Dim sngTemp As Single

        sfdGrades.ShowDialog()
        swrFile = New System.IO.StreamWriter(sfdGrades.FileName)

        rtbOut.Clear()

        Call TestScores(1, mbytScores1)
        Call TestScores(2, mbytScores2)
        Call TestScores(3, mbytScores3)
        Call TestScores(4, mbytScores4)

        rtbOut.AppendText("             Final Grades" & ControlChars.NewLine & ControlChars.NewLine)
        rtbOut.AppendText("ID   Average Grade" & ControlChars.NewLine)

        For i = 0 To mstrID.GetUpperBound(0)
            intTotal = System.Convert.ToInt32(mbytScores1(i)) + System.Convert.ToInt32(mbytScores2(i)) + System.Convert.ToInt32(mbytScores3(i)) + System.Convert.ToInt32(mbytScores4(i))
            sngAverage(i) = intTotal / 4
        Next i


        For i = 0 To mstrID.GetUpperBound(0) - 1
            intMin = i
            For j = i + 1 To mstrID.GetUpperBound(0)
                If mstrID(intMin) > mstrID(j) Then
                    intMin = j
                End If
            Next j
            strTemp = mstrID(i)
            mstrID(i) = mstrID(intMin)
            mstrID(intMin) = strTemp
            sngTemp = sngAverage(i)
            sngAverage(i) = sngAverage(intMin)
            sngAverage(intMin) = sngTemp

        Next i

        For i = 0 To mstrID.GetUpperBound(0)
            Select Case sngAverage(i)
                Case Is >= 90
                    strGrade = "A"
                Case Is >= 80
                    strGrade = "B"
                Case Is >= 70
                    strGrade = "C"
                Case Is >= 60
                    strGrade = "D"
                Case Else
                    strGrade = "F"
            End Select

            strLine = mstrID(i) & "  " & sngAverage(i).ToString("N1") & "     " & strGrade
            swrFile.WriteLine(strLine)
            rtbOut.AppendText(strLine & ControlChars.NewLine)
        Next i
        swrFile.Close()

        mnuFileSaveGrades.Enabled = False

    End Sub

    Private Sub mnuFileExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileExit.Click
        End

    End Sub
End Class
